
let read_lines_from_channel chan = 
  let rec read_lines' lines =
    try
      let line = input_line chan in
        read_lines' (line :: lines)
    with
      End_of_file -> List.rev lines
    in
    read_lines' []
;;

let write_lines_to_channel chan lines =
  List.iter (function line -> output_string chan (line ^ "\n")) lines
;;

let read_lines filename =
  if filename = "" then
    read_lines_from_channel stdin
  else
    let inchan = open_in filename in
    let lines = read_lines_from_channel inchan in
      close_in inchan;
      lines
;;

let read_string filename =
  let lines = read_lines filename in
    String.concat "\n" lines
;;

let write_lines filename lines =
  if filename = "" then
    write_lines_to_channel stdout lines
  else
    let outchan = open_out filename in
      write_lines_to_channel outchan lines;
      close_out outchan
;;

let write_string filename str =
  if filename = "" then
    output_string stdout str
  else
    let outchan = open_out filename in
      output_string outchan str;
      close_out outchan
;;

let split3 list_of_triples = 
  let f = (fun (x,y,z) (xs,ys,zs) -> (x::xs, y::ys, z::zs)) in
    List.fold_right f list_of_triples ([],[],[])
;;
