(** Module Utx
    Utility functions used throughout LOOM compiler *)

(** Return a list of strings corresponding to lines read in from an input
    channel. Example: to read from stdin, use 'read_lines stdin'. *)
val read_lines_from_channel : in_channel -> string list

(** Write a list of strings to output channel. *)
val write_lines_to_channel : out_channel -> string list -> unit

(** Return a list of strings corresponding to lines read in from an input
    file. Examples: to read from stdin, use 'read_lines ""'. To read from
    a file called "foo.txt", use 'read_lines "foo.txt"'. *)
val read_lines : string -> string list

(** Given a filename, read in a string.  If argument is "", use stdin. *)
val read_string : string -> string

(** Given a filename, write a list of strings to the file.  If argument is "",
    use stdout. *)
val write_lines : string -> string list -> unit

(** Given a filename, write string to the file.  If argument is "", use stdout. *)
val write_string : string -> string -> unit

(** split3: analog of List.split for lists of triples *)
val split3 : ('a * 'b  * 'c) list -> 'a list * 'b list * 'c list
